#include "automata.h"


Regle initRules(char * fileName) {
  fstream file(fileName, ios::in);

  if (file.is_open()) {
    // 5 tats + l'tat "bord"
    unsigned n = 5 + 1;

    Regle rules = new unsigned[n * n * n];

    unsigned value;
    for(unsigned i = 0; i < n * n * n; i++) {
      file >> value;
      rules[i] = value;
    }

    return rules;
  } else
    cerr << "Impossible d'ouvrir " << fileName << endl;
}

int main(int argc, char **argv) {
  int nbStates = 5;

  Automata automate(17);

  // initialise l'automate  partir d'un fichier
  Regle rules = initRules("best.dat");

  cout << automate.f(rules, 16) << endl;
  
  unsigned nFire ;
  char str[255];
  for(unsigned i = 2; i <= 17; i++) {
    nFire = automate.evol(rules, i);
    cout << "longueur " << i << " : " << nFire << endl;
    sprintf(str, "svg/best16_%d.svg", i);
    automate.print(i, 2 * i - 2, str);
  } 

  cout << automate.f2(rules, 17) << endl;

}
